//------------------------------------------------------------------
//
//------------------------------------------------------------------
//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  LimeGreen
#property indicator_color4  PaleVioletRed
#property indicator_width3  3
#property indicator_width4  3

//
//
//
//
//

extern int TrixPeriod   = 14;
extern int TrixPrice    = PRICE_CLOSE;
extern int SignalPeriod = 9;
extern int SignalMode   = MODE_LWMA;

//
//
//
//
//

double trixhu[];
double trixhd[];
double trixhbu[];
double trixhbd[];
double trix[];
double sign[];
double diff[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,trixhu);  SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,trixhd);  SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,trixhbu); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,trixhbd); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,trix);
   SetIndexBuffer(5,sign);
   SetIndexBuffer(6,diff);
   SetIndexBuffer(7,trend);
   IndicatorShortName("Trix ("+TrixPeriod+","+SignalPeriod+")");
   return(0);
}

//
//
//
//
//

double workTrix[][3];
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(workTrix,0)!=Bars) ArrayResize(workTrix,Bars);

   //
   //
   //
   //
   //

   double alpha = 2.0/(1.0+TrixPeriod);
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         double price = MathLog(iMA(NULL,0,1,0,MODE_SMA,TrixPrice,i));
            workTrix[r][0] =  workTrix[r-1][0]+alpha*(price         -workTrix[r-1][0]);
            workTrix[r][1] =  workTrix[r-1][1]+alpha*(workTrix[r][0]-workTrix[r-1][1]);
            workTrix[r][2] =  workTrix[r-1][2]+alpha*(workTrix[r][1]-workTrix[r-1][2]);
         
            if (workTrix[r-1][2]!=0)
                 trix[i] = (workTrix[r][2]-workTrix[r-1][2])/workTrix[r-1][2];
            else trix[i] = 0.00;
      }   
      for (i=limit; i>=0; i--)
      {
         sign[i]  = iMAOnArray(trix,0,SignalPeriod,0,SignalMode,i);
         diff[i]  = trix[i]-sign[i];
         trend[i] = trend[i+1];
            if (diff[i]>0) trend[i] =  1;
            if (diff[i]<0) trend[i] = -1;
            
            if (trend[i]== 1)
            {
               trixhu[i]  = High[i]; 
               trixhd[i]  = Low[i];
               trixhbu[i] = MathMax(Open[i],Close[i]);
               trixhbd[i] = MathMin(Open[i],Close[i]);
            }               
            if (trend[i]== -1)
            {
               trixhu[i]  = Low[i];
               trixhd[i]  = High[i];
               trixhbu[i] = MathMin(Open[i],Close[i]);
               trixhbd[i] = MathMax(Open[i],Close[i]);
            }               
    }     
   return(0);
}